// Copyright 2017 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax --opt --no-always-opt

function foo() {}

assertEquals(0, v8GetOptimizationCount(foo));
assertEquals(0, v8GetDeoptCount(foo));

foo();
foo();
v8OptimizeFunctionOnNextCall(foo);
foo();

assertOptimized(foo);
assertEquals(1, v8GetOptimizationCount(foo));
assertEquals(0, v8GetDeoptCount(foo));

// Unlink the function.
v8DeoptimizeFunction(foo);

assertUnoptimized(foo);
assertEquals(1, v8GetOptimizationCount(foo));
assertEquals(1, v8GetDeoptCount(foo));

foo();

assertUnoptimized(foo);
assertEquals(1, v8GetOptimizationCount(foo));
assertEquals(1, v8GetDeoptCount(foo));
