// Copyright 2015 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

assertEquals("1", v8ToName(1));

assertEquals("0.5", v8ToName(.5));

assertEquals("null", v8ToName(null));

assertEquals("true", v8ToName(true));

assertEquals("false", v8ToName(false));

assertEquals("undefined", v8ToName(undefined));

assertEquals("random text", v8ToName("random text"));

assertEquals(Symbol.toPrimitive, v8ToName(Symbol.toPrimitive));

var a = { toString: function() { return "xyz" }};
assertEquals("xyz", v8ToName(a));

var b = { valueOf: function() { return 42 }};
assertEquals("[object Object]", v8ToName(b));

var c = {
  toString: function() { return "x"},
  valueOf: function() { return 123 }
};
assertEquals("x", v8ToName(c));

var d = {
  [Symbol.toPrimitive]: function(hint) { return hint }
};
assertEquals("string", v8ToName(d));

var e = new Date(0);
assertEquals(e.toString(), v8ToName(e));
